// CrossWorks HD44780 driver.

#ifndef __hd44780_H
#define __hd44780_H

#define	DISP_ON			0x0c
#define	DISP_OFF		0x08
#define	CLR_DISP		0x01
#define	CUR_HOME		0x02
#define	ENTRY_INC		0x06
#define	ENTRY_DEC		0x04
#define	DD_RAM_ADDR		0x80
#define	DD_RAM_ADDR2		0xc0
#define	DD_RAM_ADDR3		0x28
#define	CG_RAM_ADDR		0x40

extern bool lcd_state_on;
extern bool lcd_cursor_on;

void hd44780_reset(void);
void hd44780_putc(unsigned char u);
void hd44780_puts(unsigned char y, unsigned char x, const char *s, int len );
void hd44780_center_string( unsigned char row, int offset, const char *s );
void hd44780_set_cursor_position(unsigned char y, unsigned char x);
void hd44780_set_direction( int reverse );
void hd44780_define_char(unsigned char address, const unsigned char *pattern);
void hd44780_clear(void);
void hd44780_cursor_left(void);
void hd44780_cursor_right(void);
void hd44780_cursor_on(void);
void hd44780_cursor_off(void);
void hd44780_display_off(void);
void hd44780_display_on(void);

// Low-level access
void hd44780_send_cmd(unsigned char cmd);

#endif
