#ifndef morse_h
#define morse_h

#include "main.h"
#include "keyer.h"

struct dit_dah_timing
{
  int           dit;
  int           dah;
  int           intercharacter;
  int           interword;
};

extern struct dit_dah_timing morse_timing;
extern I2S_HandleTypeDef hi2s2;
extern I2S_HandleTypeDef hi2s3;
extern u32    mic_samples[2][2*SAMPLE_BUF_LEN];
extern int    samples_per_cycle;
extern short  sine_wave[DECAY_STEPS][2*MAX_SINE_SAMPLES];
extern volatile int sine_wave_decay;
extern volatile enum paddle_states paddle_state;
extern volatile enum main_modes main_mode;
extern volatile enum decoder_modes decoder_mode;

void          cw_on( void );
void          cw_off( void );
void          send_dit( void );
void          send_dah( void );
void          send_cw( u8 cw_char );
char          decode_symbol( u32 sym );
void          decode_tx_morse_code( void );

#endif
