#ifndef threads_h
#define threads_h

#include "main.h"
#include "keyer.h"
#include "cmsis_os.h"

#define TaskNotify( xTaskToNotify, ulValue ) xTaskNotify( xTaskToNotify, ulValue, eSetBits)
#define TaskNotifyISR( xTaskToNotify, ulValue ) xTaskNotifyFromISR( xTaskToNotify, ulValue, eSetBits, NULL )

// options thread
#define NOTIFY_LOAD_OPTIONS	 (1<<0)
#define NOTIFY_SAVE_OPTIONS	 (1<<1)
#define NOTIFY_CHANGE_OPTIONS	 (1<<2)
#define NOTIFY_SAVE_STRING	 (1<<3)
// lcd thread
#define NOTIFY_CHARS		 (1<<0)
#define NOTIFY_CLEAR		 (1<<1)
#define NOTIFY_CURSOR_ON	 (1<<2)
#define NOTIFY_CURSOR_OFF	 (1<<3)
#define NOTIFY_DECODER_LINE	 (1<<4)
#define NOTIFY_PARAMETER_DISPLAY (1<<5)
#define NOTIFY_SAVEOPT_DISPLAY	 (1<<6)
#define NOTIFY_STRING_DISPLAY	 (1<<7)
// tx_cw thread
#define NOTIFY_LETTER		 (1<<0)
#define NOTIFY_PADDLE		 (1<<1)
// tx_decode thread
#define NOTIFY_DECODE_SYMBOL	 (1<<0)
// rx_decode thread
#define NOTIFY_START_CAPTURE	 (1<<0)
#define NOTIFY_DFT_BUF0		 (1<<1)
#define NOTIFY_DFT_BUF1		 (1<<2)
// timing_decode thread
#define NOTIFY_NEW_DELTA	 (1<<0)

extern char   current_string[];
extern volatile int string_wptr;
extern volatile int fn_key;
extern u8     cw_tx_buffer[];
extern u32    cw_wptr, cw_rptr;
extern osThreadId thread_init_lcd;
extern osThreadId thread_beacon;
extern osThreadId thread_tx_cw;
extern osThreadId thread_tx_decode;
extern osThreadId thread_lcd;
extern osThreadId thread_options;
#ifdef ENABLE_CW_DECODE
extern osThreadId thread_rx_decode;
extern osThreadId thread_timing_decode;
extern char   decoder_char_buffer[];
#endif                          // ENABLE_CW_DECODE

void          init_lcd_thread( void const *argument );
void          beacon_thread( void const *argument );
void          lcd_thread( void const *argument );
void          tx_cw_thread( void const *argument );
void          tx_decode_thread( void const *argument );
void          options_thread( void const *argument );
#ifdef ENABLE_CW_DECODE
void          rx_decode_thread( void const *argument );
void          timing_decode_thread( void const *argument );
#endif                          // ENABLE_CW_DECODE

#endif                          // threads_h
