  .syntax unified
  .cpu cortex-m4
  .fpu softvfp
  .thumb

.global  g_Vectors
.global  boot_handler
.global  default_handler

  .section  .ivt_vector,"a"
    
g_Vectors:
  .word  0
  .word  boot_handler
  .word  NMI_Handler
  .word  HardFault_Handler
  .word  MemManage_Handler
  .word  BusFault_Handler
  .word  UsageFault_Handler
  .size  g_Vectors, .-g_Vectors
  
/*******************************************************************************/
  .section  .ivt,"ax"
  .thumb_func

boot_handler:  
   ldr  lr, flash_start
   ldr  lr, [lr,#4]
   bx  lr
flash_start:       
   .word __FLASH_segment_start__
.size  boot_handler, .-boot_handler

default_handler:
infinite_loop:
   b  infinite_loop
  .size  default_handler, .-default_handler

   .weak      NMI_Handler
   .thumb_set NMI_Handler,default_handler
  
   .weak      HardFault_Handler
   .thumb_set HardFault_Handler,default_handler
  
   .weak      MemManage_Handler
   .thumb_set MemManage_Handler,default_handler
  
   .weak      BusFault_Handler
   .thumb_set BusFault_Handler,default_handler

   .weak      UsageFault_Handler
   .thumb_set UsageFault_Handler,default_handler

   .weak      SVC_Handler
   .thumb_set SVC_Handler,default_handler

   .weak      DebugMon_Handler
   .thumb_set DebugMon_Handler,default_handler

   .weak      PendSV_Handler
   .thumb_set PendSV_Handler,default_handler

   .weak      SysTick_Handler
   .thumb_set SysTick_Handler,default_handler              
